import java.util.*;
import java.io.*;

public class B {

	String dirs = "ULDR";

	class Event {
		int time, dir, id;

		public Event(int time, int dir, int id) {
			super();
			this.time = time;
			this.dir = dir;
			this.id = id;
		}
	}

	void solve() {
		int n = in.nextInt();
		Event[] events = new Event[n];
		for (int i = 0; i < n; i++) {
			events[i] = new Event(in.nextInt(), dirs.indexOf(in.nextToken().charAt(0)), i);
		}

		int[] ans = new int[n];
		Arrays.fill(ans, -1);
		Queue<Event>[] qs = new Queue[4];
		for (int i = 0; i < 4; i++) {
			qs[i] = new ArrayDeque<>();
		}
		int ptr = 0;
		int curTime = 0;
		while (ptr < n || !qs[0].isEmpty() || !qs[1].isEmpty() || !qs[2].isEmpty() || !qs[3].isEmpty()) {
			while (ptr < n && events[ptr].time == curTime) {
				qs[events[ptr].dir].add(events[ptr]);
				ptr++;
			}

			boolean changed = false;
			boolean[] move = new boolean[4];
			for (int i = 0; i < 4; i++) {
				if (!qs[i].isEmpty() && qs[(i + 1) % 4].isEmpty()) {
					changed = true;
					move[i] = true;
//					ans[qs[i].poll().id] = curTime;
//					break;
				}
			}
			if (!changed) {
				if (!qs[0].isEmpty() && !qs[1].isEmpty() && !qs[2].isEmpty() && !qs[3].isEmpty()) {
					break;
				}
				curTime = events[ptr].time;
			} else {
				for (int i = 0; i < 4; i++) {
					if (move[i]) {
						ans[qs[i].poll().id] = curTime;
					}
				}
				curTime++;
			}
		}

		for (int i = 0; i < n; i++) {
			out.println(ans[i]);
		}
	}

	FastScanner in;
	PrintWriter out;

	void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		solve();
		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String s) {
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		public String nextToken() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
				}
			}
			return st.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new B().run();
	}
}
