# Usage examples:
# python3 gen_normals.py n=5000 k=0,1000  v=1,1000000 sigma=50 cnt=5
import random
import bisect
from sys import argv, stderr

random.seed(" ".join(argv), 2)

MAXV = 1000000000
n = (1, 5000)
k = (0, MAXV)
v = (1, MAXV)
sigma = (0, 15000000)
cnt = 1
rdm = False

for s in argv[1:]:
	if '=' in s:
		if s[:s.find('=')] in ("n", "k", "v", "sigma", "cnt", "rdm"):
			exec(s)
		else:
			print("Wrong argument", s, file=stderr)

if type(n) != int:
	n = random.randint(n[0], n[1])
if type(k) != int:
	k = random.randint(k[0], k[1])
if type(v) == int:
	v = (1, v)
if type(sigma) == int:
	sigma = (sigma, sigma)
if type(cnt) != int:
	cnt = random.randint(cnt[0], cnt[1])

probs = [random.randint(1, 1000) for i in range(cnt)]
probss = [0]
for x in probs:
	probss.append(probss[-1] + x)
distrs = [(random.randint(v[0], v[1]),
		   random.randint(sigma[0], sigma[1])) for i in range(cnt)]
print(distrs, file=stderr)

def getValue():
	nn = random.randint(0, probss[-1] - 1)
	mu, sg = distrs[bisect.bisect_right(probss, nn) - 1]
	return min(max(1, int(random.normalvariate(mu, sg))), MAXV)

print(n, k)
print(" ".join(str(getValue()) for i in range(n)))
