#include <iostream>
#include <vector>
#include <bitset>
#include <numeric>
#include <map>
#include <ctime>
#include <string>
#include <algorithm>
#include <queue>
#include <cstring>
#include <set>
#include <unordered_set>

using namespace std;

#define pii pair <int, int>

const long long N = 2e3;

pii v[N];
long long c;

long long gcd(long long a, long long b)
{
	while (b)
	{
		c = a % b;
		a = b;
		b = c;
	}
	return a < 0 ? -a : a;
}

struct fraction
{
	long long numerator;
	long long denominator;
	int id;
	bool operator < (const fraction &a)
	{
		return ((long long)numerator) * a.denominator < ((long long)a.numerator) * denominator;
	}
	void relax()
	{
		long long g = gcd(denominator, numerator);
		numerator /= g;
		denominator /= g;
	}
	fraction& operator -=(const fraction &x)
	{
		//make sure it will not overflow.
		numerator *= x.denominator;
		numerator -= x.numerator * denominator;
		denominator *= x.denominator;
		relax();
		return *this;
	}
	fraction& operator +=(const fraction &x)
	{
		//make sure it will not overflow.
		numerator *= x.denominator;
		numerator += x.numerator * denominator;
		denominator *= x.denominator;
		relax();
		return *this;
	}
};

fraction median(const fraction &a, const fraction &b)
{
	fraction c = { a.numerator + b.numerator, a.denominator + b.denominator };
	c.relax();
	return c;
}

fraction sum[N][N];
fraction arr[N];

fraction operator + (const fraction &a, const fraction &b)
{
	fraction c = a;
	c += b;
	return c;
}

fraction operator - (const fraction &a, const fraction &b)
{
	fraction c = a;
	c -= b;
	return c;
}

inline bool cmp(const pii &a, const pii &b)
{
	return a.first * b.second < a.second * b.first;
}

int MAGIC = 2;

int main()
{
	::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int k;
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
		scanf("%d%d", &v[i].first, &v[i].second),
		arr[i] = { v[i].first, v[i].second, i };

	sort(arr, arr + k);
	fraction ans = { -1LL << 30, 1 };

	for (int i = 0; i < k; ++i)
		for (int j = 0; j < k; ++j)
			sum[i][j] = median(arr[i], arr[j]);
	vector <int> answer;
	vector <int> p1(k), p2(k);
	iota(p1.begin(), p1.end(), 0);
	iota(p2.begin(), p2.end(), 0);
	random_shuffle(p1.begin(), p1.end());
	random_shuffle(p2.begin(), p2.end());
	MAGIC = min(MAGIC, k);
	for (int aa = 0; aa < MAGIC; aa++)
	{
		int a = p1[aa];
		for (int b = 0; b < a; b++)
			for (int cc = 0; cc < MAGIC; cc++)
			{
				int c = p2[cc];
				for (int d = 0; d < c; d++)
				{
					if (a == c || a == d) continue;
					if (b == c || b == d) continue;
					fraction q = sum[b][d] - sum[a][c];
					if (ans < q)
						ans = q,
						answer = { arr[b].id, arr[a].id, arr[d].id, arr[c].id };
				}
			}
	}
	for (int i = 0; i < 4; ++i)
		cout << answer[i] + 1 << " ";
	//cout << (long double)ans.numerator / ans.denominator << endl;
	return 0;
}
